/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PREFIXOCIA                                               */
/* Tabela : PREFIXOCIA                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PREFIXOCIA' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_PREFIXOCIA
GO

CREATE TRIGGER DTULTATU_PREFIXOCIA
ON PREFIXOCIA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PREFIXOCIA', null, 'CDFILIAL='+ CDFILIAL+ ';'+
                                         'CDCIA='   + CDCIA   + ';'+
                                         'SGPREFIXO='+ SGPREFIXO+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PREFIXOCIA
      SET DTULTATUPREC = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(PREFIXOCIA.CDFILIAL    ,0) = ISNULL(INSERTED.CDFILIAL    ,0)) AND
            (ISNULL(PREFIXOCIA.CDCIA       ,0) = ISNULL(INSERTED.CDCIA       ,0)) AND
            (ISNULL(PREFIXOCIA.SGPREFIXO   ,0) = ISNULL(INSERTED.SGPREFIXO   ,0)) AND
            (ISNULL(PREFIXOCIA.CDEQUIP     ,0) = ISNULL(INSERTED.CDEQUIP     ,0)) AND
            (ISNULL(PREFIXOCIA.SGPREFIXO   ,0) = ISNULL(INSERTED.SGPREFIXO   ,0)) AND
            (ISNULL(PREFIXOCIA.QTTOTPAXPREF,0) = ISNULL(INSERTED.QTTOTPAXPREF,0));
   END;
END;
GO

