/* Tabela SERIENF: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
tabela SERIENF */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela SERIENF utilizando
a tabela Geral de Logs de Operaes */

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_FIS_SERIENF' AND
                 TYPE   = 'TR' 		        AND
	              U.UID  = O.UID             AND
	              U.NAME = USER)
DROP TRIGGER LOG_FIS_SERIENF
GO

CREATE TRIGGER LOG_FIS_SERIENF
ON SERIENF
FOR INSERT, UPDATE, DELETE
AS
   DECLARE  @V_DSREMOTEADDR VARCHAR(15);
   DECLARE  @V_DSREMOTEHOST VARCHAR(15);
   DECLARE  @V_DSSERVERRDM  VARCHAR(20);
   DECLARE  @V_DSSERVMETHOD VARCHAR(30);
   DECLARE  @V_DSREMOTEOPER VARCHAR(12);
   DECLARE  @V_USUARIO      VARCHAR(40);
   DECLARE  @V_TIPO         VARCHAR(1);
   DECLARE  @V_ITPESQ       VARCHAR(40);
   DECLARE  @V_DESC         VARCHAR(600);
   DECLARE  @V_DTOPER       DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO       VARCHAR(1);

   DECLARE  @V_CDEMPRESA_OLD    VARCHAR(2);
   DECLARE  @V_CDINSCESTA_OLD   VARCHAR(16);
   DECLARE  @V_CDINSCMUNI_OLD   VARCHAR(16);
   DECLARE  @V_CDSERIE_OLD      VARCHAR(5);
   DECLARE  @V_DSSERIE_OLD      VARCHAR(20);
   DECLARE  @V_NRMAXITNF_OLD    SMALLINT;
   DECLARE  @V_NRMAXSERVNF_OLD  SMALLINT;
   DECLARE  @V_CDCTRLNUMENF_OLD VARCHAR(10);
   DECLARE  @V_CDRELMODENF_OLD  VARCHAR(100);
   DECLARE  @V_CDRELESPENF_OLD  VARCHAR(100);
   DECLARE  @V_CDRELDANFE_OLD   VARCHAR(100);
   DECLARE  @V_CDRELCCE_OLD     VARCHAR(100);
   DECLARE  @V_CDEXPSERIENF_OLD VARCHAR(10);
   DECLARE  @V_IDCONMAXITEM_OLD VARCHAR(1);
   DECLARE  @V_IDUTDTPREMIS_OLD VARCHAR(1);
   DECLARE  @V_CDSERIENFE_OLD   VARCHAR(5);
   DECLARE  @V_CDSERIENFESCAN_OLD VARCHAR(5);

   DECLARE  @V_CDEMPRESA_NEW    VARCHAR(2);
   DECLARE  @V_CDINSCESTA_NEW   VARCHAR(16);
   DECLARE  @V_CDINSCMUNI_NEW   VARCHAR(16);
   DECLARE  @V_CDSERIE_NEW      VARCHAR(5);
   DECLARE  @V_DSSERIE_NEW      VARCHAR(20);
   DECLARE  @V_NRMAXITNF_NEW    SMALLINT;
   DECLARE  @V_NRMAXSERVNF_NEW  SMALLINT;
   DECLARE  @V_CDCTRLNUMENF_NEW VARCHAR(10);
   DECLARE  @V_CDRELMODENF_NEW  VARCHAR(100);
   DECLARE  @V_CDRELESPENF_NEW  VARCHAR(100);
   DECLARE  @V_CDRELDANFE_NEW   VARCHAR(100); 
   DECLARE  @V_CDRELCCE_NEW     VARCHAR(100);
   DECLARE  @V_CDEXPSERIENF_NEW VARCHAR(10);
   DECLARE  @V_IDCONMAXITEM_NEW VARCHAR(1);
   DECLARE  @V_IDUTDTPREMIS_NEW VARCHAR(1);
   DECLARE  @V_CDSERIENFE_NEW   VARCHAR(5);
   DECLARE  @V_CDSERIENFESCAN_NEW VARCHAR(5);
BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';

   EXEC WEBTUNNING @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                   @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                   @P_DSSERVERRDM = @V_DSSERVERRDM OUTPUT,
                   @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                   @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;

   EXEC NMUSUARIO @P_NMUSUARIO = @V_USUARIO OUTPUT;

   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
     'D' IDCOMANDO,
         CDEMPRESA,
         CDINSCESTA,
         CDINSCMUNI,
         CDSERIE,
         DSSERIE,
         NRMAXITNF,
         NRMAXSERVNF,
         CDCTRLNUMENF,
         CDRELMODENF,
         CDRELESPENF,
         CDRELDANFE,
         CDRELCCE,
         CDEXPSERIENF,
         IDCONMAXITEM,
         IDUTDTPREMIS,
         CDSERIENFE,
         CDSERIENFESCAN,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
   FROM
     DELETED
   WHERE
     CDEMPRESA+CDINSCESTA+CDINSCMUNI+CDSERIE NOT IN (SELECT CDEMPRESA+CDINSCESTA+CDINSCMUNI+CDSERIE FROM INSERTED)
   UNION ALL

   SELECT
     'U' IDCOMANDO,
      DELETED.CDEMPRESA,
      DELETED.CDINSCESTA,
      DELETED.CDINSCMUNI,
      DELETED.CDSERIE,
      DELETED.DSSERIE,
      DELETED.NRMAXITNF,
      DELETED.NRMAXSERVNF,
      DELETED.CDCTRLNUMENF,
      DELETED.CDRELMODENF,
      DELETED.CDRELESPENF,
      DELETED.CDRELDANFE,
      DELETED.CDRELCCE,
      DELETED.CDEXPSERIENF,
      DELETED.IDCONMAXITEM,
      DELETED.IDUTDTPREMIS,
      DELETED.CDSERIENFE,
      DELETED.CDSERIENFESCAN,
      INSERTED.CDEMPRESA,
      INSERTED.CDINSCESTA,
      INSERTED.CDINSCMUNI,
      INSERTED.CDSERIE,
      INSERTED.DSSERIE,
      INSERTED.NRMAXITNF,
      INSERTED.NRMAXSERVNF,
      INSERTED.CDCTRLNUMENF,
      INSERTED.CDRELMODENF,
      INSERTED.CDRELESPENF,
      INSERTED.CDRELDANFE,
      INSERTED.CDRELCCE,
      INSERTED.CDEXPSERIENF,
      INSERTED.IDCONMAXITEM,
      INSERTED.IDUTDTPREMIS,
      INSERTED.CDSERIENFE,
      INSERTED.CDSERIENFESCAN
   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDEMPRESA  = DELETED.CDEMPRESA  AND
      INSERTED.CDINSCESTA = DELETED.CDINSCESTA AND
      INSERTED.CDINSCMUNI = DELETED.CDINSCMUNI AND
      INSERTED.CDSERIE    = DELETED.CDSERIE
   UNION ALL

   SELECT
      'I' IDCOMANDO,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      CDEMPRESA,
      CDINSCESTA,
      CDINSCMUNI,
      CDSERIE,
      DSSERIE,
      NRMAXITNF,
      NRMAXSERVNF,
      CDCTRLNUMENF,
      CDRELMODENF,
      CDRELESPENF,
      CDRELDANFE,
      CDRELCCE,
      CDEXPSERIENF,
      IDCONMAXITEM,
      IDUTDTPREMIS,
      CDSERIENFE,
      CDSERIENFESCAN
   FROM
      INSERTED
   WHERE
      CDEMPRESA+CDINSCESTA+CDINSCMUNI+CDSERIE NOT IN (SELECT CDEMPRESA+CDINSCESTA+CDINSCMUNI+CDSERIE FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDEMPRESA_OLD,
                                 @V_CDINSCESTA_OLD,
                                 @V_CDINSCMUNI_OLD,
                                 @V_CDSERIE_OLD,
                                 @V_DSSERIE_OLD,
                                 @V_NRMAXITNF_OLD,
                                 @V_NRMAXSERVNF_OLD,
                                 @V_CDCTRLNUMENF_OLD,
                                 @V_CDRELMODENF_OLD,
                                 @V_CDRELESPENF_OLD,
                                 @V_CDRELDANFE_OLD,
                                 @V_CDRELCCE_OLD,
                                 @V_CDEXPSERIENF_OLD,
                                 @V_IDCONMAXITEM_OLD,
                                 @V_IDUTDTPREMIS_OLD,
                                 @V_CDSERIENFE_OLD,
                                 @V_CDSERIENFESCAN_OLD,

                                 @V_CDEMPRESA_NEW,
                                 @V_CDINSCESTA_NEW,
                                 @V_CDINSCMUNI_NEW,
                                 @V_CDSERIE_NEW,
                                 @V_DSSERIE_NEW,
                                 @V_NRMAXITNF_NEW,
                                 @V_NRMAXSERVNF_NEW,
                                 @V_CDCTRLNUMENF_NEW,
                                 @V_CDRELMODENF_NEW,
                                 @V_CDRELESPENF_NEW,
                                 @V_CDRELDANFE_NEW,
                                 @V_CDRELCCE_NEW,
                                 @V_CDEXPSERIENF_NEW,
                                 @V_IDCONMAXITEM_NEW,
                                 @V_IDUTDTPREMIS_NEW,
                                 @V_CDSERIENFE_NEW,
                                 @V_CDSERIENFESCAN_NEW;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_CDSERIE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Serie=' + @V_CDSERIE_OLD;
         END;

         IF @V_DSSERIE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Descr=' + @V_DSSERIE_OLD;
         END;

         IF @V_NRMAXITNF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' MaxProdNF=' + CONVERT(VARCHAR,@V_NRMAXITNF_OLD);
         END;

         IF @V_NRMAXSERVNF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' MaxServNF=' + CONVERT(VARCHAR,@V_NRMAXSERVNF_OLD);
         END;

         IF @V_CDCTRLNUMENF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' ContrNum=' + @V_CDCTRLNUMENF_OLD;
         END;

         IF @V_CDRELMODENF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' ModeloNF=' + @V_CDRELMODENF_OLD;
         END;

         IF @V_CDRELESPENF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' ModeloEsp=' + @V_CDRELESPENF_OLD;
         END;

         IF @V_CDRELDANFE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' ModeloDanfe=' + @V_CDRELDANFE_OLD;
         END;

         IF @V_CDRELCCE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' ModeloCCe=' +@V_CDRELCCE_OLD;
         END;
         
         IF @V_CDEXPSERIENF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CodExport=' + @V_CDEXPSERIENF_OLD;
         END;

         IF @V_IDCONMAXITEM_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' ConsMaxProd=' + @V_IDCONMAXITEM_OLD;
         END;

         IF @V_IDUTDTPREMIS_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' UtilDtProces=' + @V_IDUTDTPREMIS_OLD;
         END;

         IF @V_CDSERIENFE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' SerieNFe=' + @V_CDSERIENFE_OLD;
         END;

         IF @V_CDSERIENFESCAN_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' SerieScan=' + @V_CDSERIENFESCAN_OLD;
         END;

         SET @V_TIPO   = '3';
         SET @V_ITPESQ = @V_CDEMPRESA_OLD + @V_CDINSCESTA_OLD + @V_CDINSCMUNI_OLD + @V_CDSERIE_OLD;
      END
      ELSE
         IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
            IF (ISNULL(@V_CDSERIE_OLD,' ')        <> ISNULL(@V_CDSERIE_NEW,' '))      OR
               (ISNULL(@V_DSSERIE_OLD,' ')        <> ISNULL(@V_DSSERIE_NEW,' '))      OR
               (ISNULL(@V_NRMAXITNF_OLD,0)        <> ISNULL(@V_NRMAXITNF_NEW,0))      OR
               (ISNULL(@V_NRMAXSERVNF_OLD,0)      <> ISNULL(@V_NRMAXSERVNF_NEW,0))    OR
               (ISNULL(@V_CDCTRLNUMENF_OLD,' ')   <> ISNULL(@V_CDCTRLNUMENF_NEW,' ')) OR
               (ISNULL(@V_CDRELMODENF_OLD,' ')    <> ISNULL(@V_CDRELMODENF_NEW,' '))  OR
               (ISNULL(@V_CDRELESPENF_OLD,' ')    <> ISNULL(@V_CDRELESPENF_NEW,' '))  OR
               (ISNULL(@V_CDRELDANFE_OLD,' ')     <> ISNULL(@V_CDRELDANFE_NEW,' '))   OR
               (ISNULL(@V_CDRELCCE_OLD,' ')       <> ISNULL(@V_CDRELCCE_NEW,' '))     OR
               (ISNULL(@V_CDEXPSERIENF_OLD,' ')   <> ISNULL(@V_CDEXPSERIENF_NEW,' ')) OR
               (ISNULL(@V_IDCONMAXITEM_OLD,' ')   <> ISNULL(@V_IDCONMAXITEM_NEW,' ')) OR
               (ISNULL(@V_IDUTDTPREMIS_OLD,' ')   <> ISNULL(@V_IDUTDTPREMIS_NEW,' ')) OR
               (ISNULL(@V_CDSERIENFE_OLD,' ')     <> ISNULL(@V_CDSERIENFE_NEW,' '))   OR
               (ISNULL(@V_CDSERIENFESCAN_OLD,' ') <> ISNULL(@V_CDSERIENFESCAN_NEW,' ')) BEGIN

               SET @V_TIPO   = '2';
               SET @V_ITPESQ = @V_CDEMPRESA_OLD + @V_CDINSCESTA_OLD + @V_CDINSCMUNI_OLD + @V_CDSERIE_OLD;
            END;
         END
         ELSE BEGIN
            SET @V_TIPO   = '1';
            SET @V_ITPESQ = @V_CDEMPRESA_NEW + @V_CDINSCESTA_NEW + @V_CDINSCMUNI_NEW + @V_CDSERIE_NEW;
         END;

      IF @V_CDSERIE_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + 'Serie=' + @V_CDSERIE_NEW;
      END;

      IF @V_DSSERIE_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Descr=' + @V_DSSERIE_NEW;
      END;

      IF @V_NRMAXITNF_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' MaxProdNF=' + CONVERT(VARCHAR,@V_NRMAXITNF_NEW);
      END;

      IF @V_NRMAXSERVNF_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' MaxServNF=' + CONVERT(VARCHAR,@V_NRMAXSERVNF_NEW);
      END;

      IF @V_CDCTRLNUMENF_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' ContrNum=' + @V_CDCTRLNUMENF_NEW;
      END;

      IF @V_CDRELMODENF_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' ModeloNF=' + @V_CDRELMODENF_NEW ;
      END;

      IF @V_CDRELESPENF_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' ModeloEsp=' + @V_CDRELESPENF_NEW;
      END;

      IF @V_CDRELDANFE_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' ModeloDanfe=' + @V_CDRELDANFE_NEW;
      END;

      IF @V_CDRELCCE_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' ModeloCCe=' + @V_CDRELCCE_NEW;
      END;

      IF @V_CDEXPSERIENF_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' CodExport=' + @V_CDEXPSERIENF_NEW;
      END;

      IF @V_IDCONMAXITEM_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' ConsMaxProd=' + @V_IDCONMAXITEM_NEW;
      END;

      IF @V_IDUTDTPREMIS_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' UtilDtProces=' + @V_IDUTDTPREMIS_NEW;
      END;

      IF @V_CDSERIENFE_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' SerieNFe=' + @V_CDSERIENFE_NEW;
      END;

      IF @V_CDSERIENFESCAN_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' SerieScan=' + @V_CDSERIENFESCAN_NEW;
      END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               SET @V_DESC = SUBSTRING(@V_DESC, 1, 600);

               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                   DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                   DSMETUSUOPER, CDORESPOPER)
               VALUES
                  ('SERIENF',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,    @V_ITPESQ, @V_DESC,
                   @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST,
                   @V_DSSERVMETHOD, @V_DSREMOTEOPER);
            END;
         END;
      END;

      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_CDEMPRESA_OLD,
                                    @V_CDINSCESTA_OLD,
                                    @V_CDINSCMUNI_OLD,
                                    @V_CDSERIE_OLD,
                                    @V_DSSERIE_OLD,
                                    @V_NRMAXITNF_OLD,
                                    @V_NRMAXSERVNF_OLD,
                                    @V_CDCTRLNUMENF_OLD,
                                    @V_CDRELMODENF_OLD,
                                    @V_CDRELESPENF_OLD,
                                    @V_CDRELDANFE_OLD,
                                    @V_CDRELCCE_OLD,
                                    @V_CDEXPSERIENF_OLD,
                                    @V_IDCONMAXITEM_OLD,
                                    @V_IDUTDTPREMIS_OLD,
                                    @V_CDSERIENFE_OLD,
                                    @V_CDSERIENFESCAN_OLD,

                                    @V_CDEMPRESA_NEW,
                                    @V_CDINSCESTA_NEW,
                                    @V_CDINSCMUNI_NEW,
                                    @V_CDSERIE_NEW,
                                    @V_DSSERIE_NEW,
                                    @V_NRMAXITNF_NEW,
                                    @V_NRMAXSERVNF_NEW,
                                    @V_CDCTRLNUMENF_NEW,
                                    @V_CDRELMODENF_NEW,
                                    @V_CDRELESPENF_NEW,
                                    @V_CDRELDANFE_NEW,
                                    @V_CDRELCCE_NEW,
                                    @V_CDEXPSERIENF_NEW,
                                    @V_IDCONMAXITEM_NEW,
                                    @V_IDUTDTPREMIS_NEW,
                                    @V_CDSERIENFE_NEW,
                                    @V_CDSERIENFESCAN_NEW;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIS_SERIENF','5.85.xxx';
GO
