
/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PALM                                                 */
/* Tabela : PALM                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 27/04/2005 - Rafael Christopher de Souza e Silva                           */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PALM' and
            type = 'TR'                  and
            u.uid = o.uid                and
            u.name = USER)
   DROP TRIGGER DTULTATU_PALM
GO

CREATE TRIGGER DTULTATU_PALM
ON PALM
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PALM', null, 'CDPALM='+ CDPALM+ ';'+
                                           'CDFILIAL='+ CDFILIAL+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PALM
      SET DTULTATUPALM = GETDATE()
      FROM INSERTED;
   END;
END;
GO
