var Fis00111_RelatorioCustomizavelEmissaoLancamentosNF_Controller = function(ZHPromise, General, templateManager, ScreenService, ZhFilterPreferences)
{
    /* Variável de Inicialização */
    var self = this; 
    var CDTIPOOPER      = false; // Armazena o tipo de operação do filtro atual. Serve para se transferir os valores para o próximo filtro
    var IDENTRSAIDOP_AR = false;

    /* Abre Filtro */
    self.openFilter = function(widget){
        self.searchUnidadeSession(widget).then(function(filial){
            var rowSetFilter = {
                'CDFILIAL': widget.filial.CDFILIAL,
                'NMFILIAL': widget.filial.NMFILIAL,
                'IDENTRSAIDOP': widget.filial.IDENTRSAIDOP
            };
            ZhFilterPreferences.setOriginalFilter(widget.id, rowSetFilter);
            ZhFilterPreferences.openFilterWidget(widget, rowSetFilter);
        }).catch(function(){
            ZhFilterPreferences.setOriginalFilter(widget.id);
            ZhFilterPreferences.openFilterWidget(widget);
        });
    };
    
    /* Busca Unidade Sessão */
    self.searchUnidadeSession = function(widget){
        var deferred = ZHPromise.defer();
        
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": getLocalVar('CDFILIAL')
            }
        ];
        
        General.callRestEngine('fis#/crud/filial', 'FilterData', filter).then(function(response){
            widget.filial = response.dataset.filial[0];
            deferred.resolve();
        });
        
        return deferred.promise;
    };
    
    /* Aplica Filtro */
    self.applyFilter = function(widget, filterRow){

        var cdfilial     = filterRow.CDFILIAL;
        var identrsaidop = filterRow.ENTRSAID;
        var cdtipooper   = filterRow.CDTIPOOPER;
        var dtentrsaid   = filterRow.DTENTRSAID;
        var idstatus     = filterRow.IDSTATUS;
        var idstatusnfe  = filterRow.IDSTATUSNFE;
        
        if(identrsaidop == 'E'){
             widget.dataSource.name = 'fis_relatorios#/crud/notafiscal_entrada_emissaoLancNF';
             widget.floatingControl.xlsAction.dataSourceName = "notafiscal_entrada_emissaoLancNF";
             widget.floatingControl.pdfAction.dataSourceName = "notafiscal_entrada_emissaoLancNF";
        }else{
            widget.dataSource.name = 'fis_relatorios#/crud/notafiscal_saida_emissaoLancNF';
            widget.floatingControl.xlsAction.dataSourceName = "notafiscal_saida_emissaoLancNF";
            widget.floatingControl.pdfAction.dataSourceName = "notafiscal_saida_emissaoLancNF";
        }
        
        widget.dataSourceFilter.forEach(function (filtro) {
            switch(filtro.name){
                case 'P_CDTIPOOPER': filtro.value = (cdtipooper) ? (cdtipooper.length > 0) ? '_' + cdtipooper.join('_')+'_' : null : null;
                    break;
                 case 'P_DTINI': filtro.value = dtentrsaid.start;
                    break;
                case 'P_DTFIN': filtro.value = dtentrsaid.end;
                    break;
                case 'P_FILIAL': filtro.value = cdfilial;
                    break;
                case 'P_TCDTIPOOPER': filtro.value = (cdtipooper) ? (cdtipooper.length > 0) ? null : 'T' : 'T';
                    break;
                case 'P_IDSTATUS': filtro.value = (idstatus) ? (idstatus.length > 0) ? '_'+idstatus.join('_')+'_' : null : null;
                    break;
                case 'P_TIDSTATUS': filtro.value = (idstatus) ? (idstatus.length > 0) ? null : 'T' : 'T';
                    break;
                case 'P_IDSTATUSNFE': filtro.value = (idstatusnfe) ? (idstatusnfe.length > 0) ? '_'+idstatusnfe.join('_')+'_' : null : null;
                    break;
                case 'P_TIDSTATUSNFE': filtro.value = (idstatusnfe) ? (idstatusnfe.length > 0) ? null : 'T' : 'T';
                    break;
            }
        });
        
        widget.getField('CDFILIAL').filterProperties.isVisible     = false;
        widget.getField('NMFILIAL').filterProperties.isVisible     = false;
        widget.getField('DTENTRSAID').filterProperties.isVisible   = false;
        widget.getField('ENTRSAID').filterProperties.isVisible = false;
        widget.getField('CDTIPOOPER').filterProperties.isVisible   = false;
        widget.getField('IDSTATUS').filterProperties.isVisible     = false;
    };
    
    /* Altera Tipo de Nota Fiscal */
    self.changeTipoNF = function(widget){
        //self.reloadTipoOper(widget);
        self.reloadStatus(widget);
    };
    
    /* Recarrega Tipo de Operação 
    self.reloadTipoOper = function(widget){
        // Field CDTIPOOPER
        widget.fields[10].value('');
        
        // Field NMTIPOOPER c/ nome no filtro de CDTIPOOPER
        widget.fields[10].value('');
        widget.fields[10].dataSourceFilter[0].value = widget.getField('IDENTRSAIDOP').value();
        widget.fields[10].reload();
    };*/
    
    /* Recarrega Status */
    self.reloadStatus = function(widget){
        widget.getField('IDSTATUSNFE').value('');
        
        if(widget.getField('ENTRSAID').value() == 'S')
             widget.getField('IDSTATUSNFE').isVisible = true;
        else widget.getField('IDSTATUSNFE').isVisible = false;
    };
    
    this.tipoRules = function(widget) {
        var tipo = widget.currentRow.ENTRSAID;
        var field = widget.getField('CDTIPOOPER');

        if (tipo) {
            field.readOnly = false;
            field.dataSourceFilter = [
                {
                    "name": "IDENTRSAIDOP",
                    "operator": "=",
                    "value": tipo
                }
            ];
            field.reload();

        } else {
            //field.readOnly = true;
            field.dataSourceFilter = [];
        }
         widget.currentRow.IDENTRSAIDOP = null;
    };
    this.statusDaNota = function(widget){
        var status = widget.currentRow.IDSTATUSNFE;
        
        if (status == 'P'){
            status.dataSourceFilter = 'P';
        } else if (status == 'A'){
            status.dataSourceFilter = 'A';
        }else if (status == 'D'){
            status.dataSourceFilter = 'D';
        }else if (status == 'T'){
            status.dataSourceFilter = 'T';
        }else if (status == 'R'){
            status.dataSourceFilter = 'R';
        }else{
            status.dataSourceFilter = 'C';
        }
    };

};
    
/* global Configuration */
Configuration(function (ContextRegister)
{
    ContextRegister.register('Fis00111_RelatorioCustomizavelEmissaoLancamentosNF_Controller', Fis00111_RelatorioCustomizavelEmissaoLancamentosNF_Controller);
});